import { ThemingParameters } from '@ui5/webcomponents-react-base';
import React from 'react';
import { defaultMaxYAxisWidth } from './defaults';
import { getTextWidth, truncateLongLabel } from './Utils';
export const YAxisTicks = (props) => {
    var _a, _b;
    const { x, y, payload, config, secondYAxisConfig, tickFormatter, index } = props;
    const formattedValue = (_a = tickFormatter === null || tickFormatter === void 0 ? void 0 : tickFormatter(payload.value, index)) !== null && _a !== void 0 ? _a : config.formatter(payload.value);
    let textToDisplay = formattedValue;
    if (getTextWidth(formattedValue) > defaultMaxYAxisWidth) {
        for (let i = `${formattedValue}`.length; i > 0; i--) {
            textToDisplay = truncateLongLabel(formattedValue, i);
            if (getTextWidth(textToDisplay) <= defaultMaxYAxisWidth) {
                break;
            }
        }
    }
    return (React.createElement("g", { transform: `translate(${x},${y + 3})` },
        React.createElement("text", { fill: (_b = secondYAxisConfig === null || secondYAxisConfig === void 0 ? void 0 : secondYAxisConfig.color) !== null && _b !== void 0 ? _b : ThemingParameters.sapContent_LabelColor, textAnchor: secondYAxisConfig ? 'start' : 'end' }, textToDisplay)));
};
